<%

On Error Resume Next

' ============================================
' get IP address being forwarded from proxy server, if not a proxy server then
' get proper ip address from your computer
' ============================================

dim ipaddress, strsql,country, strlen, hldip

ipaddress = Request.ServerVariables("HTTP_X_FORWARDED_FOR") 
If ipaddress = "" or len(ipaddress) > 15 Then
ipaddress = Request.ServerVariables("REMOTE_ADDR") 
end if

' ================================================
' open database #1 (** EDIT THIS IF NECESSARY ** )
' ================================================

	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.Provider = "Microsoft.Jet.OLEDB.4.0"
	objconn.ConnectionString = "Data Source=" & Server.Mappath ("\guardian\IPlist.mdb")
	objconn.open

' ============================================
' check the list of IP addresses for a ban
' ============================================

strSQL = "SELECT * FROM IPtable"
set objRS = objConn.Execute(strSQL)

	while NOT objrs.EOF

' ============================================
' hldip holds the IP address, strlen gets the length of the IP address in database
' ============================================
	hldip = objrs("ip")
	strlen = len(hldip)
	sendto = objrs("redirect")  ' URL we send the banned user to

' ============================================
' check to see if there is a match in IP bans
' ============================================
	If left(ipaddress,strlen) = hldip then
		
	' update the counter because we found a banned IP
	  hits = objrs("tries") + 1 ' how many hits so far


	strSQL = "UPDATE IPtable SET tries = '" & hits & "' WHERE ip='" & hldip & "'"
	set objRS = objConn.Execute(strSQL)
		response.redirect sendto	'send user to redirect
		response.end			'stop processing code
		end if

'============================================
'next recordset
'============================================
	objrs.movenext
	wend 

'============================================
'passed IP ban check, lets check the countries
'============================================

	Dim conn, rs, sql, accessdb, strconn
	Dim ipno,ipcountry

	ipno = Dot2LongIP(ipaddress)

' ================================================
' open database #2 (** EDIT THIS IF NECESSARY ** )
' ================================================

	accessdb = server.mappath("\guardian\IPCountry.mdb")
	strconn = "PROVIDER=Microsoft.Jet.OLEDB.4.0;DATA SOURCE="
	strconn = strconn & accessDB & ";"
	Set conn = Server.CreateObject("ADODB.Connection")
	conn.open strconn


	strsql = "SELECT * FROM iptocountry WHERE " & ipno & " BETWEEN begin_num AND end_num"
	Set rs = conn.execute(strsql)

	If Not rs.EOF Then
	ipcountry = rs("country") ' two letter country code
	else
	ipcountry = "ZZ"
	End If

	strsql = "SELECT * FROM countries WHERE twoletter = '" & ipcountry & "'"
	Set rs = conn.execute(strsql)


' ================================================
' is it a banned country?
' ================================================

if rs("status") = "ban" then
response.write "You are visiting from a banned country."	' edit accordingly
response.end							' do NOT remove this line of code
end if

	rs.close
	set rs = nothing
	conn.close
	Set conn = nothing

On Error GoTo 0

' ================================================
' TOR Anonymous Connection??
' ================================================

' ================================================
' edit Filename path accordingly
' ================================================
Const Filename = "\guardian\tor_blacklist.txt"   
Const ForReading = 1, ForWriting = 2, ForAppending = 3
Const TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0

' Create a filesystem object
Dim FSO
set FSO = server.createObject("Scripting.FileSystemObject")

' Map the logical path to the physical system path
Dim Filepath
Filepath = Server.MapPath(Filename)

if FSO.FileExists(Filepath) Then

    ' Get a handle to the file
    Dim file    
    set file = FSO.GetFile(Filepath)

    ' Open the file
    Dim TextStream
    Set TextStream = file.OpenAsTextStream(ForReading, TristateUseDefault)

    ' Read the file line by line
    Do While Not TextStream.AtEndOfStream
        Dim ILine, IPArray, TmpIP
        ILine = TextStream.readline

    ' does it contain an IP address    
 If InStr( ILine, "{REMOTE_ADDR}" ) > 1 Then 

        ' Do something with "Line"    
	IpArray = Split(ILine," ")
	TmpIP = IpArray(2)	
	TmpIP = Replace(TmpIP,"^","")
	TmpIP = Replace(TmpIP,"$","")
	TmpIP = Replace(TmpIP,"\","")
   if ipaddress = TmpIP then
   response.write "TOR servers are banned."	' edit accordingly
   response.end
   end if

 end if 
    Loop

end if
Set FSO = nothing

' ================================================
' Convert dotted IP address into IP number in long
' ================================================

Function Dot2LongIP (ByVal DottedIP)
	Dim i, pos
	Dim PrevPos, num
	If DottedIP = "" Then
		Dot2LongIP = 0
	Else
		For i = 1 To 4
			pos = InStr(PrevPos + 1, DottedIP, ".", 1)
			If i = 4 Then 
				pos = Len(DottedIP) + 1
			End If
			num = Int(Mid(DottedIP, PrevPos + 1, pos - PrevPos - 1))
			PrevPos = pos
			Dot2LongIP = ((num Mod 256) * (256 ^ (4 - i))) +   Dot2LongIP
		Next
	End If

End Function

%>

